<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/phpDoctor.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/phpdoctor.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/phpDoctor.php</h1>
<div class="comment" id="overview_description"><p>Undefined internal constants so we don't throw undefined constant errors later on</p></div>

<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Undefined internal constants so we don't throw undefined constant errors later on */
<a name="line22"></a>if (!defined('T_DOC_COMMENT')) define('T_DOC_COMMENT',0);
<a name="line23"></a>if (!defined('T_ML_COMMENT')) define('T_ML_COMMENT', 0);
<a name="line24"></a>if (!defined('T_PRIVATE')) define('T_PRIVATE', 0);
<a name="line25"></a>if (!defined('T_PROTECTED')) define('T_PROTECTED', 0);
<a name="line26"></a>if (!defined('T_PUBLIC')) define('T_PUBLIC', 0);
<a name="line27"></a>if (!defined('T_ABSTRACT')) define('T_ABSTRACT', 0);
<a name="line28"></a>if (!defined('T_FINAL')) define('T_FINAL', 0);
<a name="line29"></a>if (!defined('T_INTERFACE')) define('T_INTERFACE', 0);
<a name="line30"></a>if (!defined('T_IMPLEMENTS')) define('T_IMPLEMENTS', 0);
<a name="line31"></a>if (!defined('T_CONST')) define('T_CONST', 0);
<a name="line32"></a>if (!defined('T_THROW')) define('T_THROW', 0);
<a name="line33"></a>if (!defined('T_NAMESPACE')) define('T_NAMESPACE', 0);
<a name="line34"></a>if (!defined('T_NS_C')) define('T_NS_C', 0);
<a name="line35"></a>if (!defined('T_NS_SEPARATOR')) define('T_NS_SEPARATOR', 0);
<a name="line36"></a>if (!defined('T_USE')) define('T_USE', 0);
<a name="line37"></a>if (!defined('GLOB_ONLYDIR')) define('GLOB_ONLYDIR', FALSE);
<a name="line38"></a>
<a name="line39"></a>// load classes
<a name="line40"></a>require('classes/doc.php');
<a name="line41"></a>require('classes/rootDoc.php');
<a name="line42"></a>require('classes/packageDoc.php');
<a name="line43"></a>require('classes/programElementDoc.php');
<a name="line44"></a>require('classes/fieldDoc.php');
<a name="line45"></a>require('classes/classDoc.php');
<a name="line46"></a>require('classes/executableDoc.php');
<a name="line47"></a>require('classes/methodDoc.php');
<a name="line48"></a>require('classes/type.php');
<a name="line49"></a>require('classes/tag.php');
<a name="line50"></a>
<a name="line51"></a>/** This class holds the information from one run of PHPDoctor. Particularly
<a name="line52"></a> * the packages, classes and options specified by the user. It is the root
<a name="line53"></a> * of the parsed tokens and is passed to the doclet to be formatted into
<a name="line54"></a> * output.
<a name="line55"></a> *
<a name="line56"></a> * @package PHPDoctor
<a name="line57"></a> */
<a name="line58"></a>class PHPDoctor
<a name="line59"></a>{
<a name="line60"></a>
<a name="line61"></a>	/** The version of PHPDoctor.
<a name="line62"></a>	 *
<a name="line63"></a>	 * @var str
<a name="line64"></a>	 */
<a name="line65"></a>	var $_version = '2RC4';
<a name="line66"></a>
<a name="line67"></a>	/** The path PHPDoctor is running from.
<a name="line68"></a>	 *
<a name="line69"></a>	 * @var str
<a name="line70"></a>	 */
<a name="line71"></a>	var $_path = '.';
<a name="line72"></a>
<a name="line73"></a>	/** The time in microseconds at the start of execution.
<a name="line74"></a>	 *
<a name="line75"></a>	 * @var int
<a name="line76"></a>	 */
<a name="line77"></a>	var $_startTime = NULL;
<a name="line78"></a>
<a name="line79"></a>	/** Options from config file.
<a name="line80"></a>	 *
<a name="line81"></a>	 * @var str[]
<a name="line82"></a>	 */
<a name="line83"></a>	var $_options = array();
<a name="line84"></a>
<a name="line85"></a>	/** Turn on verbose output.
<a name="line86"></a>	 *
<a name="line87"></a>	 * @var bool
<a name="line88"></a>	 */
<a name="line89"></a>	var $_verbose = FALSE;
<a name="line90"></a>
<a name="line91"></a>	/** Turn off all output other than warnings and errors.
<a name="line92"></a>	 *
<a name="line93"></a>	 * @var bool
<a name="line94"></a>	 */
<a name="line95"></a>	var $_quiet = FALSE;
<a name="line96"></a>
<a name="line97"></a>	/** Array of files to parse.
<a name="line98"></a>	 *
<a name="line99"></a>	 * @var str[]
<a name="line100"></a>	 */
<a name="line101"></a>	var $_files = array();
<a name="line102"></a>    
<a name="line103"></a>	/** Array of files not to parse.
<a name="line104"></a>	 *
<a name="line105"></a>	 * @var str[]
<a name="line106"></a>	 */
<a name="line107"></a>    var $_ignore = array();
<a name="line108"></a>
<a name="line109"></a>	/** Directory containing files for parsing.
<a name="line110"></a>	 *
<a name="line111"></a>	 * @var str
<a name="line112"></a>	 */
<a name="line113"></a>	var $_sourcePath = array('./');
<a name="line114"></a>	var $_sourceIndex = 0;
<a name="line115"></a>
<a name="line116"></a>	/** Traverse sub-directories
<a name="line117"></a>	 *
<a name="line118"></a>	 * @var bool
<a name="line119"></a>	 */
<a name="line120"></a>	var $_subdirs = TRUE;
<a name="line121"></a>
<a name="line122"></a>	/** Package to use for elements not in a package.
<a name="line123"></a>	 *
<a name="line124"></a>	 * @var str
<a name="line125"></a>	 */
<a name="line126"></a>	var $_defaultPackage = 'The Unknown Package';
<a name="line127"></a>
<a name="line128"></a>	/** Use the filesystem path of the class as the package it should be in.
<a name="line129"></a>	 *
<a name="line130"></a>	 * @var bool
<a name="line131"></a>	 */
<a name="line132"></a>	var $_useClassPathAsPackage = FALSE;
<a name="line133"></a>
<a name="line134"></a>	/** Ignore any package tags in the source code.
<a name="line135"></a>	 *
<a name="line136"></a>	 * @var bool
<a name="line137"></a>	 */
<a name="line138"></a>	var $_ignorePackageTags = FALSE;
<a name="line139"></a>
<a name="line140"></a>	/** Overview file. The "source" file that contains the overview
<a name="line141"></a>	 * documentation.
<a name="line142"></a>	 *
<a name="line143"></a>	 * @var str
<a name="line144"></a>	 */
<a name="line145"></a>	var $_overview = NULL;
<a name="line146"></a>
<a name="line147"></a>	/** Package comment directory. if set, PHPDoctor will look in this directory
<a name="line148"></a>	 * for package comment files. Otherwise it looks in a directory named after
<a name="line149"></a>	 * the package ala Javadoc.
<a name="line150"></a>	 *
<a name="line151"></a>	 * @var str
<a name="line152"></a>	 */
<a name="line153"></a>	var $_packageCommentDir = NULL;
<a name="line154"></a>
<a name="line155"></a>	/** Parse out global variables.
<a name="line156"></a>	 *
<a name="line157"></a>	 * @var bool
<a name="line158"></a>	 */
<a name="line159"></a>	var $_globals = TRUE;
<a name="line160"></a>
<a name="line161"></a>	/** Parse out global constants.
<a name="line162"></a>	 *
<a name="line163"></a>	 * @var bool
<a name="line164"></a>	 */
<a name="line165"></a>	var $_constants = TRUE;
<a name="line166"></a>
<a name="line167"></a>	/** Display class tree.
<a name="line168"></a>	 *
<a name="line169"></a>	 * @var bool
<a name="line170"></a>	 */
<a name="line171"></a>	var $_tree = TRUE;
<a name="line172"></a>
<a name="line173"></a>	/** Parse only public classes and members.
<a name="line174"></a>	 *
<a name="line175"></a>	 * @var bool
<a name="line176"></a>	 */
<a name="line177"></a>	var $_public = TRUE;
<a name="line178"></a>
<a name="line179"></a>	/** Parse protected and public classes and members.
<a name="line180"></a>	 *
<a name="line181"></a>	 * @var bool
<a name="line182"></a>	 */
<a name="line183"></a>	var $_protected = FALSE;
<a name="line184"></a>
<a name="line185"></a>	/** Parse all classes and members.
<a name="line186"></a>	 *
<a name="line187"></a>	 * @var bool
<a name="line188"></a>	 */
<a name="line189"></a>	var $_private = FALSE;
<a name="line190"></a>
<a name="line191"></a>	/** Specifies the name of the class that starts the doclet used in generating
<a name="line192"></a>	 * the documentation.
<a name="line193"></a>	 *
<a name="line194"></a>	 * @var str
<a name="line195"></a>	 */
<a name="line196"></a>	var $_doclet = 'standard';
<a name="line197"></a>
<a name="line198"></a>	/** Specifies the name of the text formatter class.
<a name="line199"></a>	 *
<a name="line200"></a>	 * @var str
<a name="line201"></a>	 */
<a name="line202"></a>	var $_formatter = 'htmlStandardFormatter';
<a name="line203"></a>
<a name="line204"></a>	/** Specifies the path to the doclet starting class file. If the doclet class
<a name="line205"></a>	 * is not in a file named <_doclet>/<_doclet>.php then this path should
<a name="line206"></a>	 * include the filename of the class file also.
<a name="line207"></a>	 *
<a name="line208"></a>	 * @var str
<a name="line209"></a>	 */
<a name="line210"></a>	var $_docletPath = 'doclets';
<a name="line211"></a>
<a name="line212"></a>	/** Specifies the path to the taglets to use.
<a name="line213"></a>	 *
<a name="line214"></a>	 * @var str
<a name="line215"></a>	 */
<a name="line216"></a>	var $_tagletPath = 'taglets';
<a name="line217"></a>
<a name="line218"></a>	/** Specifies the path to the formatters to use.
<a name="line219"></a>	 *
<a name="line220"></a>	 * @var str
<a name="line221"></a>	 */
<a name="line222"></a>	var $_formatterPath = 'formatters';
<a name="line223"></a>
<a name="line224"></a>	/** The path and filename of the current file being parsed.
<a name="line225"></a>	 *
<a name="line226"></a>	 * @var str
<a name="line227"></a>	 */
<a name="line228"></a>	var $_currentFilename = NULL;
<a name="line229"></a>	
<a name="line230"></a>    /** Whether or not to use PEAR compatibility mode for first sentence tags.
<a name="line231"></a>     *
<a name="line232"></a>     * @var boolean
<a name="line233"></a>     */
<a name="line234"></a>    var $_pearCompat = FALSE;
<a name="line235"></a>    
<a name="line236"></a>	/** Constructor
<a name="line237"></a>	 *
<a name="line238"></a>	 * @param str config The configuration file to use for this run of PHPDoctor
<a name="line239"></a>	 */
<a name="line240"></a>	function phpDoctor($config = 'default.ini')
<a name="line241"></a>    {
<a name="line242"></a>
<a name="line243"></a>		// record start time
<a name="line244"></a>		$this->_startTime = $this->_getTime();
<a name="line245"></a>	
<a name="line246"></a>		// set the path
<a name="line247"></a>		$this->_path = dirname(dirname(__FILE__));
<a name="line248"></a>		
<a name="line249"></a>		// read config file
<a name="line250"></a>		if (is_file($config)) {
<a name="line251"></a>			$this->_options = @parse_ini_file($config);
<a name="line252"></a>			if (count($this->_options) == 0) {
<a name="line253"></a>				$this->error('Could not parse configuration file "'.$config.'"');
<a name="line254"></a>				exit;
<a name="line255"></a>			}
<a name="line256"></a>		} else {
<a name="line257"></a>			$this->error('Could not find configuration file "'.$config.'"');
<a name="line258"></a>			exit;
<a name="line259"></a>		}
<a name="line260"></a>		
<a name="line261"></a>		// set phpdoctor options
<a name="line262"></a>		if (isset($this->_options['verbose'])) {
<a name="line263"></a>			$this->_verbose = $this->_options['verbose'];
<a name="line264"></a>			$this->verbose('Being verbose');
<a name="line265"></a>		}
<a name="line266"></a>		if (isset($this->_options['quiet'])) $this->_quiet = $this->_options['quiet'];
<a name="line267"></a>        
<a name="line268"></a>		if (isset($this->_options['source_path'])) {
<a name="line269"></a>            $this->_sourcePath = array();
<a name="line270"></a>            foreach (explode(',', $this->_options['source_path']) as $path) {
<a name="line271"></a>                $this->_sourcePath[] = $this->fixPath($path, getcwd());
<a name="line272"></a>            }
<a name="line273"></a>        }
<a name="line274"></a>        
<a name="line275"></a>		if (isset($this->_options['subdirs'])) {
<a name="line276"></a>		    $this->_subdirs = $this->_options['subdirs'];
<a name="line277"></a>		}
<a name="line278"></a>		
<a name="line279"></a>		if (isset($this->_options['files'])) {
<a name="line280"></a>			$files = explode(',', $this->_options['files']);
<a name="line281"></a>		} else {
<a name="line282"></a>			$files = array('*.php');
<a name="line283"></a>		}
<a name="line284"></a>		if (isset($this->_options['ignore'])) {
<a name="line285"></a>			$this->_ignore = explode(',', $this->_options['ignore']);
<a name="line286"></a>		}
<a name="line287"></a>		
<a name="line288"></a>		$this->verbose('Searching for files to parse...');
<a name="line289"></a>        $this->_files = array();
<a name="line290"></a>        foreach ($this->_sourcePath as $path) {
<a name="line291"></a>            $this->_files[$path] = array_unique($this->_buildFileList($files, $path));
<a name="line292"></a>        }
<a name="line293"></a>		if (count($this->_files) == 0) {
<a name="line294"></a>			$this->error('Could not find any files to parse');
<a name="line295"></a>			exit;
<a name="line296"></a>		}
<a name="line297"></a>        
<a name="line298"></a>		if (isset($this->_options['default_package'])) $this->_defaultPackage = $this->_options['default_package'];
<a name="line299"></a>		if (isset($this->_options['use_class_path_as_package'])) $this->_useClassPathAsPackage = $this->_options['use_class_path_as_package'];
<a name="line300"></a>		if (isset($this->_options['ignore_package_tags'])) $this->_ignorePackageTags = $this->_options['ignore_package_tags'];
<a name="line301"></a>		
<a name="line302"></a>    // use first path element
<a name="line303"></a>		//if (isset($this->_options['overview'])) $this->_overview = $this->makeAbsolutePath($this->_options['overview'], $this->_sourcePath[0]);
<a name="line304"></a>		//if (isset($this->_options['package_comment_dir'])) $this->_packageCommentDir = $this->makeAbsolutePath($this->_options['package_comment_dir'], $this->_sourcePath[0]);
<a name="line305"></a>
<a name="line306"></a>		if (isset($this->_options['globals'])) $this->_globals = $this->_options['globals'];
<a name="line307"></a>		if (isset($this->_options['constants'])) $this->_constants = $this->_options['constants'];
<a name="line308"></a>		if (isset($this->_options['tree'])) $this->_tree = $this->_options['tree'];
<a name="line309"></a>
<a name="line310"></a>		if (isset($this->_options['private']) && $this->_options['private']) {
<a name="line311"></a>			$this->_public = TRUE;
<a name="line312"></a>			$this->_protected = TRUE;
<a name="line313"></a>			$this->_private = TRUE;
<a name="line314"></a>		} elseif (isset($this->_options['protected']) && $this->_options['protected']) {
<a name="line315"></a>			$this->_public = TRUE;
<a name="line316"></a>			$this->_protected = TRUE;
<a name="line317"></a>			$this->_private = FALSE;
<a name="line318"></a>		} elseif (isset($this->_options['public']) && $this->_options['public']) {
<a name="line319"></a>			$this->_public = TRUE;
<a name="line320"></a>			$this->_protected = FALSE;
<a name="line321"></a>			$this->_private = FALSE;
<a name="line322"></a>		}
<a name="line323"></a>
<a name="line324"></a>		if (isset($this->_options['doclet'])) $this->_doclet = $this->_options['doclet'];
<a name="line325"></a>		if (isset($this->_options['doclet_path'])) $this->_docletPath = $this->_options['doclet_path'];
<a name="line326"></a>		else $this->_docletPath = $this->_path.DIRECTORY_SEPARATOR.$this->_docletPath;
<a name="line327"></a>		if (isset($this->_options['taglet_path'])) $this->_tagletPath = $this->_options['taglet_path'];
<a name="line328"></a>		if (isset($this->_options['formatter'])) $this->_formatter = $this->_options['formatter'];
<a name="line329"></a>		if (isset($this->_options['formatter_path'])) $this->_formatterPath = $this->_options['formatter_path'];
<a name="line330"></a>		else $this->_formatterPath = $this->_path.DIRECTORY_SEPARATOR.$this->_formatterPath;
<a name="line331"></a>		
<a name="line332"></a>		if (isset($this->_options['pear_compat'])) $this->_pearCompat = $this->_options['pear_compat'];
<a name="line333"></a>	}
<a name="line334"></a>	
<a name="line335"></a>	/**
<a name="line336"></a>	 * Build a complete list of file to parse. Expand out wildcards and
<a name="line337"></a>	 * traverse directories if asked to.
<a name="line338"></a>	 *
<a name="line339"></a>	 * @param str[] files Array of filenames to expand
<a name="line340"></a>	 */
<a name="line341"></a>	function _buildFileList($files, $dir)
<a name="line342"></a>    {
<a name="line343"></a>		$list = array();
<a name="line344"></a>		
<a name="line345"></a>		$dir = realpath($dir);
<a name="line346"></a>		if (!$dir) {
<a name="line347"></a>		    return $list;
<a name="line348"></a>		}
<a name="line349"></a>		$dir = $this->fixPath($dir);
<a name="line350"></a>
<a name="line351"></a>		foreach ($files as $filename) {
<a name="line352"></a>			$filename = $this->makeAbsolutePath(trim($filename), $dir);
<a name="line353"></a>			$globResults = glob($filename); // switch slashes since old versions of glob need forward slashes
<a name="line354"></a>			if ($globResults) {
<a name="line355"></a>				foreach ($globResults as $filepath) {
<a name="line356"></a>					$okay = TRUE;
<a name="line357"></a>					foreach ($this->_ignore as $ignore) {
<a name="line358"></a>						if (strstr($filepath, trim($ignore))) {
<a name="line359"></a>							$okay = FALSE;
<a name="line360"></a>						}
<a name="line361"></a>					}
<a name="line362"></a>					if ($okay) {
<a name="line363"></a>						$list[] = realpath($filepath);
<a name="line364"></a>					}
<a name="line365"></a>				}
<a name="line366"></a>			} elseif (!$this->_subdirs) {
<a name="line367"></a>				$this->error('Could not find file "'.$filename.'"');
<a name="line368"></a>			}
<a name="line369"></a>		}
<a name="line370"></a>		
<a name="line371"></a>		if ($this->_subdirs) { // recurse into subdir
<a name="line372"></a>			$globResults = glob($dir.'*', GLOB_ONLYDIR); // get subdirs
<a name="line373"></a>			if ($globResults) {
<a name="line374"></a>				foreach ($globResults as $dirName) {
<a name="line375"></a>                    $okay = TRUE;
<a name="line376"></a>                    foreach ($this->_ignore as $ignore) {
<a name="line377"></a>                        if (strstr($dirName, trim($ignore))) {
<a name="line378"></a>                            $okay = FALSE;
<a name="line379"></a>                        }
<a name="line380"></a>                    }
<a name="line381"></a>					if ($okay && (GLOB_ONLYDIR || is_dir($dirName))) { // handle missing only dir support
<a name="line382"></a>						$list = array_merge($list, $this->_buildFileList($files, $this->makeAbsolutePath($dirName, $this->_path)));
<a name="line383"></a>					}
<a name="line384"></a>				}
<a name="line385"></a>			}
<a name="line386"></a>		}
<a name="line387"></a>
<a name="line388"></a>		return $list;
<a name="line389"></a>	}
<a name="line390"></a>	
<a name="line391"></a>	/**
<a name="line392"></a>	 * Write a message to standard output.
<a name="line393"></a>	 *
<a name="line394"></a>	 * @param str msg Message to output
<a name="line395"></a>	 */
<a name="line396"></a>	function message($msg)
<a name="line397"></a>    {
<a name="line398"></a>		if (!$this->_quiet) {
<a name="line399"></a>			echo $msg, "\n";
<a name="line400"></a>		}
<a name="line401"></a>	}
<a name="line402"></a>
<a name="line403"></a>	/**
<a name="line404"></a>	 * Write a message to standard output.
<a name="line405"></a>	 *
<a name="line406"></a>	 * @param str msg Message to output
<a name="line407"></a>	 */
<a name="line408"></a>	function verbose($msg)
<a name="line409"></a>    {
<a name="line410"></a>		if ($this->_verbose) {
<a name="line411"></a>			echo $msg, "\n";
<a name="line412"></a>		}
<a name="line413"></a>	}
<a name="line414"></a>
<a name="line415"></a>	/**
<a name="line416"></a>	 * Write a warning message to standard error.
<a name="line417"></a>	 *
<a name="line418"></a>	 * @param str msg Warning message to output
<a name="line419"></a>	 */
<a name="line420"></a>	function warning($msg)
<a name="line421"></a>    {
<a name="line422"></a>		if (!defined('STDERR')) define('STDERR', fopen("php://stderr", "wb"));
<a name="line423"></a>		fwrite(STDERR, 'WARNING: '.$msg."\n");
<a name="line424"></a>	}
<a name="line425"></a>
<a name="line426"></a>	/**
<a name="line427"></a>	 * Write an error message to standard error.
<a name="line428"></a>	 *
<a name="line429"></a>	 * @param str msg Error message to output
<a name="line430"></a>	 */
<a name="line431"></a>	function error($msg)
<a name="line432"></a>    {
<a name="line433"></a>		if (!defined('STDERR')) define('STDERR', fopen("php://stderr", "wb"));
<a name="line434"></a>		fwrite(STDERR, 'ERROR: '.$msg."\n");
<a name="line435"></a>	}
<a name="line436"></a>
<a name="line437"></a>	/**
<a name="line438"></a>	 * Get the current time in microseconds.
<a name="line439"></a>	 *
<a name="line440"></a>	 * @return int
<a name="line441"></a>	 */
<a name="line442"></a>	function _getTime()
<a name="line443"></a>    {
<a name="line444"></a>		$microtime = explode(' ', microtime());
<a name="line445"></a>		return $microtime[0] + $microtime[1];
<a name="line446"></a>	}
<a name="line447"></a>	
<a name="line448"></a>	/**
<a name="line449"></a>	 * Turn path into an absolute path using the given prefix?
<a name="line450"></a>	 *
<a name="line451"></a>	 * @param str path Path to make absolute
<a name="line452"></a>	 * @param str prefix Absolute path to append to relative path
<a name="line453"></a>	 * @return str
<a name="line454"></a>	 */
<a name="line455"></a>	function makeAbsolutePath($path, $prefix)
<a name="line456"></a>    {
<a name="line457"></a>		if (
<a name="line458"></a>			substr($path, 0, 1) == '/' || // unix root
<a name="line459"></a>			substr($path, 1, 2) == ':\\' || // windows root
<a name="line460"></a>			substr($path, 0, 2) == '~/' || // unix home directory
<a name="line461"></a>			substr($path, 0, 2) == '\\\\' || // windows network location
<a name="line462"></a>			preg_match('|^[a-z]+://|', $path) // url
<a name="line463"></a>		) {
<a name="line464"></a>			return $path;
<a name="line465"></a>		} else {
<a name="line466"></a>		    $absPath = $this->fixPath($prefix).$path;
<a name="line467"></a>		    $count = 1;
<a name="line468"></a>		    while ($count > 0) {
<a name="line469"></a>		        $absPath = preg_replace('|\w+/\.\./|', '', $absPath, -1, $count);
<a name="line470"></a>		    }
<a name="line471"></a>		    $absPath = str_replace('./', '', $absPath);
<a name="line472"></a>			return $absPath;
<a name="line473"></a>		}
<a name="line474"></a>	}
<a name="line475"></a>	
<a name="line476"></a>	/**
<a name="line477"></a>	 * Add a trailing slash to a path if it does not have one.
<a name="line478"></a>	 *
<a name="line479"></a>	 * @param str path Path to postfix
<a name="line480"></a>	 * @return str
<a name="line481"></a>	 */
<a name="line482"></a>	function fixPath($path)
<a name="line483"></a>    {
<a name="line484"></a>        if (substr($path, -1, 1) != '/' && substr($path, -1, 1) != '\\') {
<a name="line485"></a>			return $path.'/';
<a name="line486"></a>		} else {
<a name="line487"></a>			return $path;
<a name="line488"></a>		}
<a name="line489"></a>	}
<a name="line490"></a>
<a name="line491"></a>	/** Return the path PHPDoctor is running from.
<a name="line492"></a>	 *
<a name="line493"></a>	 * @return str
<a name="line494"></a>	 */
<a name="line495"></a>	function docletPath()
<a name="line496"></a>    {
<a name="line497"></a>		//return $this->makeAbsolutePath($this->fixPath($this->_docletPath).$this->fixPath($this->_doclet), $this->_path);
<a name="line498"></a>		return realpath($this->fixPath($this->_docletPath).$this->fixPath($this->_doclet)).'/';
<a name="line499"></a>	}
<a name="line500"></a>
<a name="line501"></a>	/** Return the source path.
<a name="line502"></a>	 *
<a name="line503"></a>	 * @return str
<a name="line504"></a>	 */
<a name="line505"></a>	function sourcePath()
<a name="line506"></a>    {
<a name="line507"></a>		return realpath($this->_sourcePath[$this->_sourceIndex]);
<a name="line508"></a>	}
<a name="line509"></a>
<a name="line510"></a>	/** Return the version of PHPDoctor.
<a name="line511"></a>	 *
<a name="line512"></a>	 * @return str
<a name="line513"></a>	 */
<a name="line514"></a>	function version()
<a name="line515"></a>    {
<a name="line516"></a>		return $this->_version;
<a name="line517"></a>	}
<a name="line518"></a>
<a name="line519"></a>	/** Return the default package.
<a name="line520"></a>	 *
<a name="line521"></a>	 * @return str
<a name="line522"></a>	 */
<a name="line523"></a>	function defaultPackage()
<a name="line524"></a>    {
<a name="line525"></a>		return $this->_defaultPackage;
<a name="line526"></a>	}
<a name="line527"></a>	
<a name="line528"></a>	/** Return a reference to the set options.
<a name="line529"></a>	 *
<a name="line530"></a>	 * @return str[] An array of strings.
<a name="line531"></a>	 */
<a name="line532"></a>	function &options()
<a name="line533"></a>    {
<a name="line534"></a>		return $this->_options;
<a name="line535"></a>	}
<a name="line536"></a>
<a name="line537"></a>	/** Get a configuration option.
<a name="line538"></a>	 *
<a name="line539"></a>	 * @param str option
<a name="line540"></a>	 * @return str
<a name="line541"></a>	 */
<a name="line542"></a>	function getOption($option)
<a name="line543"></a>    {
<a name="line544"></a>		$option = '_'.$option;
<a name="line545"></a>		return $this->$option;
<a name="line546"></a>	}
<a name="line547"></a>	
<a name="line548"></a>	/** Parse files into tokens and create rootDoc.
<a name="line549"></a>	 *
<a name="line550"></a>	 * @return RootDoc
<a name="line551"></a>	 */
<a name="line552"></a>	function &parse()
<a name="line553"></a>    {
<a name="line554"></a>        
<a name="line555"></a>		$rootDoc =& new rootDoc($this);
<a name="line556"></a>		$ii = 0;
<a name="line557"></a>		foreach ($this->_files as $path => $files) {
<a name="line558"></a>		    $this->_sourceIndex = $ii++;
<a name="line559"></a>            if (isset($this->_options['overview'])) $this->_overview = $this->makeAbsolutePath($this->_options['overview'], $this->sourcePath());
<a name="line560"></a>            if (isset($this->_options['package_comment_dir'])) $this->_packageCommentDir = $this->makeAbsolutePath($this->_options['package_comment_dir'], $this->sourcePath());
<a name="line561"></a>    
<a name="line562"></a>            foreach ($files as $filename) {
<a name="line563"></a>                if ($filename) {
<a name="line564"></a>                    $this->message('Reading file "'.$filename.'"');
<a name="line565"></a>                    $fileString = @file_get_contents($filename);
<a name="line566"></a>                    if ($fileString !== FALSE) {
<a name="line567"></a>						$fileString = str_replace( "\r\n", "\n", $fileString ); // fix Windows line endings
<a name="line568"></a>						$fileString = str_replace( "\r", "\n", $fileString ); // fix ancient Mac line endings
<a name="line569"></a>						
<a name="line570"></a>                        $this->_currentFilename = $filename;
<a name="line571"></a>                        
<a name="line572"></a>                        $tokens = token_get_all($fileString);
<a name="line573"></a>                        
<a name="line574"></a>                        if (!$this->_verbose) echo 'Parsing tokens';
<a name="line575"></a>                        
<a name="line576"></a>                        /* This array holds data gathered before the type of element is
<a name="line577"></a>                        discovered and an object is created for it, including doc comment
<a name="line578"></a>                        data. This data is stored in the object once it has been created and
<a name="line579"></a>                        then merged into the objects data fields upon object completion. */
<a name="line580"></a>                        $currentData = array();
<a name="line581"></a>                        
<a name="line582"></a>                        $currentPackage = $this->_defaultPackage; // the current package
<a name="line583"></a>                        if ($this->_useClassPathAsPackage) { // magic up package name from filepath
<a name="line584"></a>                            $currentPackage .= '\\'.str_replace(' ', '\\', ucwords(str_replace(DIRECTORY_SEPARATOR, ' ', substr(dirname($filename), strlen($this->sourcePath()) + 1))));
<a name="line585"></a>                        }
<a name="line586"></a>                        $defaultPackage = $oldDefaultPackage = $currentPackage;
<a name="line587"></a>                        $fileData = array();
<a name="line588"></a>                        
<a name="line589"></a>                        $currentElement = array(); // stack of element family, current at top of stack
<a name="line590"></a>                        $ce =& $rootDoc; // reference to element at top of stack
<a name="line591"></a>                        
<a name="line592"></a>                        $open_curly_braces = FALSE;
<a name="line593"></a>                        $in_parsed_string = FALSE;
<a name="line594"></a>                        
<a name="line595"></a>                        $counter = 0;
<a name="line596"></a>                        $lineNumber = 1;
<a name="line597"></a>                        $commentNumber = 0;
<a name="line598"></a>                        
<a name="line599"></a>                        $numOfTokens = count($tokens);
<a name="line600"></a>                        for ($key = 0; $key < $numOfTokens; $key++) {
<a name="line601"></a>                            $token = $tokens[$key];
<a name="line602"></a>                            
<a name="line603"></a>                            if (!$in_parsed_string && is_array($token)) {
<a name="line604"></a>                                
<a name="line605"></a>                                $lineNumber += substr_count($token[1], "\n");
<a name="line606"></a>                                
<a name="line607"></a>                                if ($commentNumber == 1 && (
<a name="line608"></a>                                    $token[0] == T_CLASS ||
<a name="line609"></a>                                    $token[0] == T_INTERFACE ||
<a name="line610"></a>                                    $token[0] == T_FUNCTION ||
<a name="line611"></a>                                    $token[0] == T_VARIABLE
<a name="line612"></a>                                )) { // we have a code block after the 1st comment, so it is not a file level comment
<a name="line613"></a>                                    $defaultPackage = $oldDefaultPackage;
<a name="line614"></a>                                    $fileData = array();
<a name="line615"></a>                                }
<a name="line616"></a>                                
<a name="line617"></a>                                switch ($token[0]) {
<a name="line618"></a>                                
<a name="line619"></a>                                case T_COMMENT: // read comment
<a name="line620"></a>                                case T_ML_COMMENT: // and multiline comment (deprecated in newer versions)
<a name="line621"></a>                                case T_DOC_COMMENT: // and catch PHP5 doc comment token too
<a name="line622"></a>                                    $currentData = array_merge($currentData, $this->processDocComment($token[1], $rootDoc));
<a name="line623"></a>                                    if ($currentData) {
<a name="line624"></a>                                        $commentNumber++;
<a name="line625"></a>                                        if ($commentNumber == 1) {
<a name="line626"></a>                                            if (isset($currentData['package'])) { // store 1st comment incase it is a file level comment
<a name="line627"></a>                                                $oldDefaultPackage = $defaultPackage;
<a name="line628"></a>                                                $defaultPackage = $currentData['package'];
<a name="line629"></a>                                            }
<a name="line630"></a>                                            $fileData = $currentData;
<a name="line631"></a>                                        }
<a name="line632"></a>                                    }
<a name="line633"></a>                                    break;
<a name="line634"></a>                                
<a name="line635"></a>                                case T_CLASS:
<a name="line636"></a>                                // read class
<a name="line637"></a>                                    $class =& new classDoc($this->_getProgramElementName($tokens, $key), $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create class object
<a name="line638"></a>                                    $this->verbose('+ Entering '.get_class($class).': '.$class->name());
<a name="line639"></a>                                    if (isset($currentData['docComment'])) { // set doc comment
<a name="line640"></a>                                        $class->set('docComment', $currentData['docComment']);
<a name="line641"></a>                                    }
<a name="line642"></a>                                    $class->set('data', $currentData); // set data
<a name="line643"></a>                                    if (isset($currentData['package']) && $currentData['package'] != NULL) { // set package
<a name="line644"></a>                                        $currentPackage = $currentData['package'];
<a name="line645"></a>                                    }
<a name="line646"></a>                                    $class->set('package', $currentPackage);
<a name="line647"></a>                                    
<a name="line648"></a>                                    $parentPackage =& $rootDoc->packageNamed($class->packageName(), TRUE); // get parent package
<a name="line649"></a>                                    $parentPackage->addClass($class); // add class to package
<a name="line650"></a>                                    $class->setByRef('parent', $parentPackage); // set parent reference
<a name="line651"></a>                                    $currentData = array(); // empty data store
<a name="line652"></a>                                    if ($this->_includeElements($class)) {
<a name="line653"></a>                                        $currentElement[count($currentElement)] =& $class; // re-assign current element
<a name="line654"></a>                                    }
<a name="line655"></a>                                    $ce =& $class;
<a name="line656"></a>                                    break;
<a name="line657"></a>                                    
<a name="line658"></a>                                case T_INTERFACE:
<a name="line659"></a>                                // read interface
<a name="line660"></a>                                    $interface =& new classDoc($this->_getProgramElementName($tokens, $key), $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create interface object
<a name="line661"></a>                                    $this->verbose('+ Entering '.get_class($interface).': '.$interface->name());
<a name="line662"></a>                                    if (isset($currentData['docComment'])) { // set doc comment
<a name="line663"></a>                                        $interface->set('docComment', $currentData['docComment']);
<a name="line664"></a>                                    }
<a name="line665"></a>                                    $interface->set('data', $currentData); // set data
<a name="line666"></a>                                    $interface->set('interface', TRUE); // this element is an interface
<a name="line667"></a>                                    if (isset($currentData['package']) && $currentData['package'] != NULL) { // set package
<a name="line668"></a>                                        $currentPackage = $currentData['package'];
<a name="line669"></a>                                    }
<a name="line670"></a>                                    $interface->set('package', $currentPackage);
<a name="line671"></a>                                    
<a name="line672"></a>                                    $parentPackage =& $rootDoc->packageNamed($interface->packageName(), TRUE); // get parent package
<a name="line673"></a>                                    $parentPackage->addClass($interface); // add class to package
<a name="line674"></a>                                    $interface->setByRef('parent', $parentPackage); // set parent reference
<a name="line675"></a>                                    $currentData = array(); // empty data store
<a name="line676"></a>                                    if ($this->_includeElements($interface)) {
<a name="line677"></a>                                        $currentElement[count($currentElement)] =& $interface; // re-assign current element
<a name="line678"></a>                                    }
<a name="line679"></a>                                    $ce =& $interface;
<a name="line680"></a>                                    break;
<a name="line681"></a>        
<a name="line682"></a>                                case T_EXTENDS:
<a name="line683"></a>                                // get extends clause
<a name="line684"></a>                                    $superClassName = $this->_getProgramElementName($tokens, $key);
<a name="line685"></a>                                    $ce->set('superclass', $superClassName);
<a name="line686"></a>                                    if ($superClass =& $rootDoc->classNamed($superClassName) && $commentTag =& $superClass->tags('@text')) {
<a name="line687"></a>                                        $ce->setTag('@text', $commentTag);
<a name="line688"></a>                                    }
<a name="line689"></a>                                    break;
<a name="line690"></a>        
<a name="line691"></a>                                case T_IMPLEMENTS:
<a name="line692"></a>                                // get implements clause
<a name="line693"></a>                                    $interfaceName = $this->_getProgramElementName($tokens, $key);
<a name="line694"></a>                                    $interface =& $rootDoc->classNamed($interfaceName);
<a name="line695"></a>                                    if ($interface) {
<a name="line696"></a>                                        $ce->set('interfaces', $interface);
<a name="line697"></a>                                    }
<a name="line698"></a>                                    break;
<a name="line699"></a>                                    
<a name="line700"></a>                                case T_THROW:
<a name="line701"></a>                                // throws exception
<a name="line702"></a>                                    $className = $this->_getProgramElementName($tokens, $key);
<a name="line703"></a>                                    $class =& $rootDoc->classNamed($className);
<a name="line704"></a>                                    if ($class) {
<a name="line705"></a>                                        $ce->setByRef('throws', $class);
<a name="line706"></a>                                    } else {
<a name="line707"></a>                                        $ce->set('throws', $className);
<a name="line708"></a>                                    }
<a name="line709"></a>                                    break;
<a name="line710"></a>        
<a name="line711"></a>                                case T_PRIVATE:
<a name="line712"></a>                                    $currentData['access'] = 'private';
<a name="line713"></a>                                    break;
<a name="line714"></a>                                    
<a name="line715"></a>                                case T_PROTECTED:
<a name="line716"></a>                                    $currentData['access'] = 'protected';
<a name="line717"></a>                                    break;
<a name="line718"></a>                                    
<a name="line719"></a>                                case T_PUBLIC:
<a name="line720"></a>                                    $currentData['access'] = 'public';
<a name="line721"></a>                                    break;
<a name="line722"></a>                                    
<a name="line723"></a>                                case T_ABSTRACT:
<a name="line724"></a>                                    $currentData['abstract'] = TRUE;
<a name="line725"></a>                                    break;
<a name="line726"></a>                                    
<a name="line727"></a>                                case T_FINAL:
<a name="line728"></a>                                    $currentData['final'] = TRUE;
<a name="line729"></a>                                    break;
<a name="line730"></a>                                    
<a name="line731"></a>                                case T_STATIC:
<a name="line732"></a>                                    $currentData['static'] = TRUE;
<a name="line733"></a>                                    break;
<a name="line734"></a>                                    
<a name="line735"></a>                                case T_VAR:
<a name="line736"></a>                                    $currentData['var'] = 'var';
<a name="line737"></a>                                    break;
<a name="line738"></a>                                    
<a name="line739"></a>                                case T_CONST:
<a name="line740"></a>                                    $currentData['var'] = 'const';
<a name="line741"></a>                                    break;
<a name="line742"></a>                                    
<a name="line743"></a>                                case T_NAMESPACE:
<a name="line744"></a>                                case T_NS_C:
<a name="line745"></a>                                    $namespace = '';
<a name="line746"></a>                                    while($tokens[++$key][0] != T_STRING);
<a name="line747"></a>                                    $namespace = $tokens[$key++][1];
<a name="line748"></a>                                    while($tokens[$key][0] == T_NS_SEPARATOR) {
<a name="line749"></a>                                        $namespace .= $tokens[$key++][1] . $tokens[$key++][1];
<a name="line750"></a>                                    }
<a name="line751"></a>                                    $currentPackage = $defaultPackage = $oldDefaultPackage = $namespace;
<a name="line752"></a>                                    $key--;
<a name="line753"></a>                                    break;
<a name="line754"></a>                                    
<a name="line755"></a>                                case T_FUNCTION:
<a name="line756"></a>                                // read function
<a name="line757"></a>                                    $name = $this->_getProgramElementName($tokens, $key);
<a name="line758"></a>                                    $method =& new methodDoc($name, $ce, $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create method object
<a name="line759"></a>                                    $this->verbose('+ Entering '.get_class($method).': '.$method->name());
<a name="line760"></a>                                    if (isset($currentData['docComment'])) { // set doc comment
<a name="line761"></a>                                        $method->set('docComment', $currentData['docComment']); // set doc comment
<a name="line762"></a>                                    }
<a name="line763"></a>                                    $method->set('data', $currentData); // set data
<a name="line764"></a>                                    $ceClass = strtolower(get_class($ce));
<a name="line765"></a>                                    if ($ceClass == 'rootdoc') { // global function, add to package
<a name="line766"></a>                                        $this->verbose(' is a global function');
<a name="line767"></a>                                        if (isset($currentData['access']) && $currentData['access'] == 'private') $method->makePrivate();
<a name="line768"></a>                                        if (isset($currentData['package']) && $currentData['package'] != NULL) { // set package
<a name="line769"></a>                                            $method->set('package', $currentData['package']);
<a name="line770"></a>                                        } else {
<a name="line771"></a>                                            $method->set('package', $currentPackage);
<a name="line772"></a>                                        }
<a name="line773"></a>                                        $method->mergeData();
<a name="line774"></a>                                        $parentPackage =& $rootDoc->packageNamed($method->packageName(), TRUE); // get parent package
<a name="line775"></a>                                        if ($this->_includeElements($method)) {
<a name="line776"></a>                                            $parentPackage->addFunction($method); // add method to package
<a name="line777"></a>                                        }
<a name="line778"></a>                                    } elseif ($ceClass == 'classdoc' || $ceClass == 'methoddoc') { // class method, add to class
<a name="line779"></a>                                        $method->set('package', $ce->packageName()); // set package
<a name="line780"></a>                                        if ($method->name() == '__construct' || strtolower($method->name()) == strtolower($ce->name())) { // constructor
<a name="line781"></a>                                            $this->verbose(' is a constructor of '.get_class($ce).' '.$ce->name());
<a name="line782"></a>                                            $method->set("name", "__construct");
<a name="line783"></a>                                            $ce->addMethod($method);
<a name="line784"></a>                                        } else {
<a name="line785"></a>                                            if ($this->_hasPrivateName($method->name())) $method->makePrivate();
<a name="line786"></a>                                            if (isset($currentData['access']) && $currentData['access'] == 'private') $method->makePrivate();
<a name="line787"></a>                                            $this->verbose(' is a method of '.get_class($ce).' '.$ce->name());
<a name="line788"></a>                                            if ($this->_includeElements($method)) {
<a name="line789"></a>                                                $ce->addMethod($method);
<a name="line790"></a>                                            }
<a name="line791"></a>                                        }
<a name="line792"></a>                                    }
<a name="line793"></a>                                    $currentData = array(); // empty data store
<a name="line794"></a>                                    $currentElement[count($currentElement)] =& $method; // re-assign current element
<a name="line795"></a>                                    $ce =& $method;
<a name="line796"></a>                                    break;
<a name="line797"></a>        
<a name="line798"></a>                                case T_STRING:
<a name="line799"></a>                                    // read global constant
<a name="line800"></a>                                    if ($token[1] == 'define') {// && $tokens[$key + 2][0] == T_CONSTANT_ENCAPSED_STRING) {
<a name="line801"></a>                                        $const =& new fieldDoc($this->_getNext($tokens, $key, T_CONSTANT_ENCAPSED_STRING), $ce, $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create constant object
<a name="line802"></a>                                        $this->verbose('Found '.get_class($const).': global constant '.$const->name());
<a name="line803"></a>                                        $const->set('final', TRUE); // is constant
<a name="line804"></a>                                        $value = '';
<a name="line805"></a>                                        do {
<a name="line806"></a>                                            $key++;
<a name="line807"></a>                                        } while(isset($tokens[$key]) && $tokens[$key] != ',');
<a name="line808"></a>                                        $key++;
<a name="line809"></a>                                        while(isset($tokens[$key]) && $tokens[$key] != ')') {
<a name="line810"></a>                                            if (is_array($tokens[$key])) {
<a name="line811"></a>                                                $value .= $tokens[$key][1];
<a name="line812"></a>                                            } else {
<a name="line813"></a>                                                $value .= $tokens[$key];
<a name="line814"></a>                                            }
<a name="line815"></a>                                            $key++;
<a name="line816"></a>                                        }
<a name="line817"></a>                                        $value = trim($value);
<a name="line818"></a>                                        if (substr($value, 0, 5) == 'array') {
<a name="line819"></a>                                            $value = 'array(...)';
<a name="line820"></a>                                        }
<a name="line821"></a>                                        $const->set('value', $value);
<a name="line822"></a>                                        if (is_numeric($value)) {
<a name="line823"></a>                                            $const->set('type', new type('int', $rootDoc));
<a name="line824"></a>                                        } elseif (strtolower($value) == 'true' || strtolower($value) == 'false') {
<a name="line825"></a>                                            $const->set('type', new type('bool', $rootDoc));
<a name="line826"></a>                                        } elseif (
<a name="line827"></a>                                            substr($value, 0, 1) == '"' && substr($value, -1, 1) == '"' ||
<a name="line828"></a>                                            substr($value, 0, 1) == "'" && substr($value, -1, 1) == "'"
<a name="line829"></a>                                        ) {
<a name="line830"></a>                                            $const->set('type', new type('str', $rootDoc));
<a name="line831"></a>                                        }
<a name="line832"></a>                                        unset($value);
<a name="line833"></a>                                        if (isset($currentData['docComment'])) { // set doc comment
<a name="line834"></a>                                            $const->set('docComment', $currentData['docComment']);
<a name="line835"></a>                                        }
<a name="line836"></a>                                        $const->set('data', $currentData); // set data
<a name="line837"></a>                                        if (isset($currentData['package'])) { // set package
<a name="line838"></a>                                            $const->set('package', $currentData['package']);
<a name="line839"></a>                                        } else {
<a name="line840"></a>                                            $const->set('package', $currentPackage);
<a name="line841"></a>                                        }
<a name="line842"></a>                                        $const->mergeData();
<a name="line843"></a>                                        $parentPackage =& $rootDoc->packageNamed($const->packageName(), TRUE); // get parent package
<a name="line844"></a>                                        if ($this->_includeElements($const)) {
<a name="line845"></a>                                            $parentPackage->addGlobal($const); // add constant to package
<a name="line846"></a>                                        }
<a name="line847"></a>                                        $currentData = array(); // empty data store
<a name="line848"></a>                                        
<a name="line849"></a>                                    // member constant
<a name="line850"></a>                                    } elseif (isset($currentData['var']) && $currentData['var'] == 'const') {
<a name="line851"></a>                                        do {
<a name="line852"></a>                                            $key++;
<a name="line853"></a>                                            if ($tokens[$key] == '=') {
<a name="line854"></a>                                                $name = $this->_getPrev($tokens, $key, array(T_VARIABLE, T_STRING));
<a name="line855"></a>                                                $value = '';
<a name="line856"></a>                                            } elseif(isset($value) && $tokens[$key] != ',' && $tokens[$key] != ';') { // set value
<a name="line857"></a>                                                if (is_array($tokens[$key])) {
<a name="line858"></a>                                                    $value .= $tokens[$key][1];
<a name="line859"></a>                                                } else {
<a name="line860"></a>                                                    $value .= $tokens[$key];
<a name="line861"></a>                                                }
<a name="line862"></a>                                            } elseif ($tokens[$key] == ',' || $tokens[$key] == ';') {
<a name="line863"></a>                                                if (!isset($name)) {
<a name="line864"></a>                                                    $name = $this->_getPrev($tokens, $key, array(T_VARIABLE, T_STRING));
<a name="line865"></a>                                                }
<a name="line866"></a>                                                $const =& new fieldDoc($name, $ce, $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create field object
<a name="line867"></a>                                                $this->verbose('Found '.get_class($const).': '.$const->name());
<a name="line868"></a>                                                if ($this->_hasPrivateName($const->name())) $const->makePrivate();
<a name="line869"></a>                                                $const->set('final', TRUE);
<a name="line870"></a>                                                if (isset($value)) { // set value
<a name="line871"></a>                                                    $value = trim($value);
<a name="line872"></a>                                                    if (strlen($value) > 30 && substr($value, 0, 5) == 'array') {
<a name="line873"></a>                                                        $value = 'array(...)';
<a name="line874"></a>                                                    }
<a name="line875"></a>                                                    $const->set('value', $value);
<a name="line876"></a>                                                    if (is_numeric($value)) {
<a name="line877"></a>                                                        $const->set('type', new type('int', $rootDoc));
<a name="line878"></a>                                                    } elseif (strtolower($value) == 'true' || strtolower($value) == 'false') {
<a name="line879"></a>                                                        $const->set('type', new type('bool', $rootDoc));
<a name="line880"></a>                                                    } elseif (
<a name="line881"></a>                                                        substr($value, 0, 1) == '"' && substr($value, -1, 1) == '"' ||
<a name="line882"></a>                                                        substr($value, 0, 1) == "'" && substr($value, -1, 1) == "'"
<a name="line883"></a>                                                    ) {
<a name="line884"></a>                                                        $const->set('type', new type('str', $rootDoc));
<a name="line885"></a>                                                    }
<a name="line886"></a>                                                }
<a name="line887"></a>                                                if (isset($currentData['docComment'])) { // set doc comment
<a name="line888"></a>                                                    $const->set('docComment', $currentData['docComment']);
<a name="line889"></a>                                                }
<a name="line890"></a>                                                $const->set('data', $currentData); // set data
<a name="line891"></a>                                                $const->set('package', $ce->packageName()); // set package
<a name="line892"></a>                                                $const->set('static', TRUE);
<a name="line893"></a>                                                $this->verbose(' is a member constant of '.get_class($ce).' '.$ce->name());
<a name="line894"></a>                                                $const->mergeData();
<a name="line895"></a>                                                if ($this->_includeElements($const)) {
<a name="line896"></a>                                                    $ce->addConstant($const);
<a name="line897"></a>                                                }
<a name="line898"></a>                                                unset($name);
<a name="line899"></a>                                                unset($value);
<a name="line900"></a>                                            }
<a name="line901"></a>                                        } while(isset($tokens[$key]) && $tokens[$key] != ';');
<a name="line902"></a>                                        $currentData = array(); // empty data store
<a name="line903"></a>        
<a name="line904"></a>                                    // function parameter
<a name="line905"></a>                                    } elseif (strtolower(get_class($ce)) == 'methoddoc' && $ce->inBody == 0) {
<a name="line906"></a>                                        $typehint = NULL;
<a name="line907"></a>                                        do {
<a name="line908"></a>                                            $key++;
<a name="line909"></a>                                            if (!isset($tokens[$key])) break;
<a name="line910"></a>                                            if ($tokens[$key] == ',' || $tokens[$key] == ')') {
<a name="line911"></a>                                                unset($param);
<a name="line912"></a>                                            } elseif (is_array($tokens[$key])) {
<a name="line913"></a>                                                if ($tokens[$key][0] == T_STRING && !isset($param)) { // type hint
<a name="line914"></a>                                                    $typehint = $tokens[$key][1];
<a name="line915"></a>                                                } elseif ($tokens[$key][0] == T_VARIABLE && !isset($param)) {
<a name="line916"></a>                                                    $param =& new fieldDoc($tokens[$key][1], $ce, $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create constant object
<a name="line917"></a>                                                    $this->verbose('Found '.get_class($param).': '.$param->name());
<a name="line918"></a>                                                    if (isset($currentData['docComment'])) { // set doc comment
<a name="line919"></a>                                                        $param->set('docComment', $currentData['docComment']);
<a name="line920"></a>                                                    }
<a name="line921"></a>                                                    if ($typehint) {
<a name="line922"></a>                                                        $param->set('type', new type($typehint, $rootDoc));
<a name="line923"></a>                                                        $this->verbose(' has a typehint of '.$typehint);
<a name="line924"></a>                                                    }
<a name="line925"></a>                                                    $param->set('data', $currentData); // set data
<a name="line926"></a>                                                    $param->set('package', $ce->packageName()); // set package
<a name="line927"></a>                                                    $this->verbose(' is a parameter of '.get_class($ce).' '.$ce->name());
<a name="line928"></a>                                                    $param->mergeData();
<a name="line929"></a>                                                    $ce->addParameter($param);
<a name="line930"></a>                                                    $typehint = NULL;
<a name="line931"></a>                                                } elseif (isset($param) && ($tokens[$key][0] == T_STRING || $tokens[$key][0] == T_CONSTANT_ENCAPSED_STRING || $tokens[$key][0] == T_LNUMBER)) { // set value
<a name="line932"></a>                                                    $value = $tokens[$key][1];
<a name="line933"></a>                                                    $param->set('value', $value);
<a name="line934"></a>                                                    if (!$typehint) {
<a name="line935"></a>                                                        if (is_numeric($value)) {
<a name="line936"></a>                                                            $param->set('type', new type('int', $rootDoc));
<a name="line937"></a>                                                        } elseif (strtolower($value) == 'true' || strtolower($value) == 'false') {
<a name="line938"></a>                                                            $param->set('type', new type('bool', $rootDoc));
<a name="line939"></a>                                                        } elseif (
<a name="line940"></a>                                                            substr($value, 0, 1) == '"' && substr($value, -1, 1) == '"' ||
<a name="line941"></a>                                                            substr($value, 0, 1) == "'" && substr($value, -1, 1) == "'"
<a name="line942"></a>                                                        ) {
<a name="line943"></a>                                                            $param->set('type', new type('str', $rootDoc));
<a name="line944"></a>                                                        }
<a name="line945"></a>                                                    }
<a name="line946"></a>                                                }
<a name="line947"></a>                                            }
<a name="line948"></a>                                        } while(isset($tokens[$key]) && $tokens[$key] != ')');
<a name="line949"></a>                                        $currentData = array(); // empty data store
<a name="line950"></a>                                    }
<a name="line951"></a>                                    break;
<a name="line952"></a>        
<a name="line953"></a>                                case T_VARIABLE:
<a name="line954"></a>                                    // read global variable
<a name="line955"></a>                                    if (strtolower(get_class($ce)) == 'rootdoc') { // global var, add to package
<a name="line956"></a>                                        $global =& new fieldDoc($tokens[$key][1], $ce, $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create constant object
<a name="line957"></a>                                        $this->verbose('Found '.get_class($global).': global variable '.$global->name());
<a name="line958"></a>                                        if (isset($tokens[$key - 1][0]) && isset($tokens[$key - 2][0]) && $tokens[$key - 2][0] == T_STRING && $tokens[$key - 1][0] == T_WHITESPACE) {
<a name="line959"></a>                                            $global->set('type', new type($tokens[$key - 2][1], $rootDoc));
<a name="line960"></a>                                        }
<a name="line961"></a>                                        while (isset($tokens[$key]) && $tokens[$key] != '=' && $tokens[$key] != ';') {
<a name="line962"></a>                                            $key++;
<a name="line963"></a>                                        }
<a name="line964"></a>                                        if (isset($tokens[$key]) && $tokens[$key] == '=') {
<a name="line965"></a>                                            $default = '';
<a name="line966"></a>                                            $key2 = $key + 1;
<a name="line967"></a>                                            do {
<a name="line968"></a>                                                if (is_array($tokens[$key2])) {
<a name="line969"></a>                                                    if ($tokens[$key2][1] != '=') $default .= $tokens[$key2][1];
<a name="line970"></a>                                                } else {
<a name="line971"></a>                                                    if ($tokens[$key2] != '=') $default .= $tokens[$key2];
<a name="line972"></a>                                                }
<a name="line973"></a>                                                $key2++;
<a name="line974"></a>                                            } while(isset($tokens[$key2]) && $tokens[$key2] != ';' && $tokens[$key2] != ',' && $tokens[$key2] != ')');
<a name="line975"></a>                                            $global->set('value', trim($default, ' ()')); // set value
<a name="line976"></a>                                        }
<a name="line977"></a>                                        if (isset($currentData['docComment'])) { // set doc comment
<a name="line978"></a>                                            $global->set('docComment', $currentData['docComment']);
<a name="line979"></a>                                        }
<a name="line980"></a>                                        $global->set('data', $currentData); // set data
<a name="line981"></a>                                        if (isset($currentData['package'])) { // set package
<a name="line982"></a>                                            $global->set('package', $currentData['package']);
<a name="line983"></a>                                        } else {
<a name="line984"></a>                                            $global->set('package', $currentPackage);
<a name="line985"></a>                                        }
<a name="line986"></a>                                        $global->mergeData();
<a name="line987"></a>                                        $parentPackage =& $rootDoc->packageNamed($global->packageName(), TRUE); // get parent package
<a name="line988"></a>                                        if ($this->_includeElements($global)) {
<a name="line989"></a>                                            $parentPackage->addGlobal($global); // add constant to package
<a name="line990"></a>                                        }
<a name="line991"></a>                                        $currentData = array(); // empty data store
<a name="line992"></a>                                        
<a name="line993"></a>                                // read member variable
<a name="line994"></a>                                    } elseif (
<a name="line995"></a>                                        (isset($currentData['var']) && $currentData['var'] == 'var') || 
<a name="line996"></a>                                        (isset($currentData['access']) && ($currentData['access'] == 'public' || $currentData['access'] == 'protected' || $currentData['access'] == 'private'))
<a name="line997"></a>                                    ) {
<a name="line998"></a>                                        unset($name);
<a name="line999"></a>                                        do {
<a name="line1000"></a>                                            $key++;
<a name="line1001"></a>                                            if ($tokens[$key] == '=') { // start value
<a name="line1002"></a>                                                $name = $this->_getPrev($tokens, $key, T_VARIABLE);
<a name="line1003"></a>                                                $value = '';
<a name="line1004"></a>                                                $bracketCount = 0;
<a name="line1005"></a>                                            } elseif (isset($value) && ($tokens[$key] != ',' || $bracketCount > 0) && $tokens[$key] != ';') { // set value
<a name="line1006"></a>                                                if ($tokens[$key] == '(') {
<a name="line1007"></a>                                                    $bracketCount++;
<a name="line1008"></a>                                                } elseif ($tokens[$key] == ')') {
<a name="line1009"></a>                                                    $bracketCount--;
<a name="line1010"></a>                                                }
<a name="line1011"></a>                                                if (is_array($tokens[$key])) {
<a name="line1012"></a>                                                    $value .= $tokens[$key][1];
<a name="line1013"></a>                                                } else {
<a name="line1014"></a>                                                    $value .= $tokens[$key];
<a name="line1015"></a>                                                }
<a name="line1016"></a>                                            } elseif ($tokens[$key] == ',' || $tokens[$key] == ';') {
<a name="line1017"></a>                                                if (!isset($name)) {
<a name="line1018"></a>                                                    $name = $this->_getPrev($tokens, $key, T_VARIABLE);
<a name="line1019"></a>                                                }
<a name="line1020"></a>                                                $field =& new fieldDoc($name, $ce, $rootDoc, $filename, $lineNumber, $this->sourcePath()); // create field object
<a name="line1021"></a>                                                $this->verbose('Found '.get_class($field).': '.$field->name());
<a name="line1022"></a>                                                if ($this->_hasPrivateName($field->name())) $field->makePrivate();
<a name="line1023"></a>                                                if (isset($value)) { // set value
<a name="line1024"></a>                                                    $value = trim($value);
<a name="line1025"></a>                                                    if (strlen($value) > 30 && substr($value, 0, 5) == 'array') {
<a name="line1026"></a>                                                        $value = 'array(...)';
<a name="line1027"></a>                                                    }
<a name="line1028"></a>                                                    $field->set('value', $value);
<a name="line1029"></a>                                                }
<a name="line1030"></a>                                                if (isset($currentData['docComment'])) { // set doc comment
<a name="line1031"></a>                                                    $field->set('docComment', $currentData['docComment']);
<a name="line1032"></a>                                                }
<a name="line1033"></a>                                                $field->set('data', $currentData); // set data
<a name="line1034"></a>                                                $field->set('package', $ce->packageName()); // set package
<a name="line1035"></a>                                                $this->verbose(' is a member variable of '.get_class($ce).' '.$ce->name());
<a name="line1036"></a>                                                $field->mergeData();
<a name="line1037"></a>                                                if ($this->_includeElements($field)) {
<a name="line1038"></a>                                                    $ce->addField($field);
<a name="line1039"></a>                                                }
<a name="line1040"></a>                                                unset($name);
<a name="line1041"></a>                                                unset($value);
<a name="line1042"></a>                                            }
<a name="line1043"></a>                                        } while(isset($tokens[$key]) && $tokens[$key] != ';');
<a name="line1044"></a>                                        $currentData = array(); // empty data store
<a name="line1045"></a>        
<a name="line1046"></a>                                    }
<a name="line1047"></a>                                    break;
<a name="line1048"></a>        
<a name="line1049"></a>                                case T_CURLY_OPEN:
<a name="line1050"></a>                                case T_DOLLAR_OPEN_CURLY_BRACES: // we must catch this so we don't accidently step out of the current block
<a name="line1051"></a>                                    $open_curly_braces = TRUE;
<a name="line1052"></a>                                    break;
<a name="line1053"></a>                                }
<a name="line1054"></a>        
<a name="line1055"></a>                            } else { // primitive tokens
<a name="line1056"></a>                            
<a name="line1057"></a>                                switch ($token) {
<a name="line1058"></a>                                case '{':
<a name="line1059"></a>                                    if (!$in_parsed_string) {
<a name="line1060"></a>                                        $ce->inBody++;
<a name="line1061"></a>                                    }
<a name="line1062"></a>                                    break;
<a name="line1063"></a>                                case '}':
<a name="line1064"></a>                                    if (!$in_parsed_string) {
<a name="line1065"></a>                                        if ($open_curly_braces) { // end of var curly brace syntax
<a name="line1066"></a>                                            $open_curly_braces = FALSE;
<a name="line1067"></a>                                        } else {
<a name="line1068"></a>                                            $ce->inBody--;
<a name="line1069"></a>                                            if ($ce->inBody == 0 && count($currentElement) > 0) {
<a name="line1070"></a>                                                $ce->mergeData();
<a name="line1071"></a>                                                $this->verbose('- Leaving '.get_class($ce).': '.$ce->name());
<a name="line1072"></a>                                                array_pop($currentElement); // re-assign current element
<a name="line1073"></a>                                                if (count($currentElement) > 0) {
<a name="line1074"></a>                                                    $ce =& $currentElement[count($currentElement) - 1];
<a name="line1075"></a>                                                } else {
<a name="line1076"></a>                                                    unset($ce);
<a name="line1077"></a>                                                    $ce =& $rootDoc;
<a name="line1078"></a>                                                }
<a name="line1079"></a>                                                $currentPackage = $defaultPackage;
<a name="line1080"></a>                                            }
<a name="line1081"></a>                                        }
<a name="line1082"></a>                                    }
<a name="line1083"></a>                                    break;
<a name="line1084"></a>                                case ';': // case for closing abstract functions
<a name="line1085"></a>                                    if (!$in_parsed_string && $ce->inBody == 0 && count($currentElement) > 0) {
<a name="line1086"></a>                                        $ce->mergeData();
<a name="line1087"></a>                                        $this->verbose('- Leaving empty '.get_class($ce).': '.$ce->name());
<a name="line1088"></a>                                        array_pop($currentElement); // re-assign current element
<a name="line1089"></a>                                        if (count($currentElement) > 0) {
<a name="line1090"></a>                                            $ce =& $currentElement[count($currentElement) - 1];
<a name="line1091"></a>                                        } else {
<a name="line1092"></a>                                            unset($ce);
<a name="line1093"></a>                                            $ce =& $rootDoc;
<a name="line1094"></a>                                        }
<a name="line1095"></a>                                    }
<a name="line1096"></a>                                    break;
<a name="line1097"></a>                                case '"': // catch parsed strings so as to ignore tokens within
<a name="line1098"></a>                                    $in_parsed_string = !$in_parsed_string;
<a name="line1099"></a>                                    break;
<a name="line1100"></a>                                }
<a name="line1101"></a>                            }
<a name="line1102"></a>                            
<a name="line1103"></a>                            $counter++;
<a name="line1104"></a>                            if ($counter > 99) {
<a name="line1105"></a>                                if (!$this->_verbose) echo '.';
<a name="line1106"></a>                                $counter = 0;
<a name="line1107"></a>                            }
<a name="line1108"></a>                        }
<a name="line1109"></a>                        if (!$this->_verbose) echo "\n";
<a name="line1110"></a>                        
<a name="line1111"></a>                        $rootDoc->addSource($filename, $fileString, $fileData);
<a name="line1112"></a>                        
<a name="line1113"></a>                    } else {
<a name="line1114"></a>                        $this->error('Could not read file "'.$filename.'"');
<a name="line1115"></a>                        exit;
<a name="line1116"></a>                    }
<a name="line1117"></a>                }
<a name="line1118"></a>            }
<a name="line1119"></a>		}
<a name="line1120"></a>        
<a name="line1121"></a>        // add parent data to child elements
<a name="line1122"></a>        $this->message('Merging superclass data');
<a name="line1123"></a>        $this->_mergeSuperClassData($rootDoc);
<a name="line1124"></a>		
<a name="line1125"></a>		return $rootDoc;
<a name="line1126"></a>	}
<a name="line1127"></a>
<a name="line1128"></a>	/** Loads and runs the doclet.
<a name="line1129"></a>	 *
<a name="line1130"></a>	 * @param RootDoc rootDoc
<a name="line1131"></a>	 * @return bool
<a name="line1132"></a>	 */
<a name="line1133"></a>	function execute(&$rootDoc)
<a name="line1134"></a>    {
<a name="line1135"></a>		$docletFile = $this->fixPath($this->_docletPath).$this->_doclet.'/'.$this->_doclet.'.php';
<a name="line1136"></a>		if (is_file($docletFile)) { // load doclet
<a name="line1137"></a>			$this->message('Loading doclet "'.$this->_doclet.'"');
<a name="line1138"></a>			require_once($this->fixPath($this->_docletPath).'/doclet.php');
<a name="line1139"></a>			require_once($docletFile);
<a name="line1140"></a>			$doclet =& new $this->_doclet($rootDoc, $this->getFormatter());
<a name="line1141"></a>		} else {
<a name="line1142"></a>			$this->error('Could not find doclet "'.$docletFile.'"');
<a name="line1143"></a>		}
<a name="line1144"></a>		$this->message('Done ('.round($this->_getTime() - $this->_startTime, 2).' seconds)');
<a name="line1145"></a>	}
<a name="line1146"></a>    
<a name="line1147"></a>	/** Creates the formatter and returns it.
<a name="line1148"></a>	 *
<a name="line1149"></a>	 * @return TextFormatter
<a name="line1150"></a>	 */
<a name="line1151"></a>	function getFormatter()
<a name="line1152"></a>    {
<a name="line1153"></a>		$formatterFile = $this->fixPath($this->_formatterPath).$this->_formatter.'.php';
<a name="line1154"></a>		if (is_file($formatterFile)) {
<a name="line1155"></a>			require_once($formatterFile);
<a name="line1156"></a>			return new $this->_formatter();
<a name="line1157"></a>		} else {
<a name="line1158"></a>			$this->error('Could not find formatter "'.$formatterFile.'"');
<a name="line1159"></a>			exit;
<a name="line1160"></a>		}
<a name="line1161"></a>	}
<a name="line1162"></a>    
<a name="line1163"></a>    /**
<a name="line1164"></a>     * @param rootDoc rootDoc
<a name="line1165"></a>     * @param str parent
<a name="line1166"></a>     */
<a name="line1167"></a>    function _mergeSuperClassData(&$rootDoc, $parent = NULL)
<a name="line1168"></a>    {
<a name="line1169"></a>        $classes =& $rootDoc->classes();
<a name="line1170"></a>        foreach ($classes as $name => $class) {
<a name="line1171"></a>            if ($classes[$name]->superclass() == $parent) {
<a name="line1172"></a>                $classes[$name]->mergeSuperClassData();
<a name="line1173"></a>                $this->_mergeSuperClassData($rootDoc, $classes[$name]->name());
<a name="line1174"></a>            }
<a name="line1175"></a>        }
<a name="line1176"></a>    }
<a name="line1177"></a>
<a name="line1178"></a>	/**
<a name="line1179"></a>	 * Recursively merge two arrays into a single array. This differs
<a name="line1180"></a>	 * from the PHP function array_merge_recursive as it replaces values
<a name="line1181"></a>	 * with the same index from the first array with items from the
<a name="line1182"></a>	 * second.
<a name="line1183"></a>	 *
<a name="line1184"></a>	 * @param mixed[] one Array one
<a name="line1185"></a>	 * @param mixed[] two Array two
<a name="line1186"></a>	 *
<a name="line1187"></a>	 * @return mixed[] Merged array
<a name="line1188"></a>	 */
<a name="line1189"></a>	function _mergeArrays($one, $two)
<a name="line1190"></a>    {
<a name="line1191"></a>		foreach ($two as $key => $item) {
<a name="line1192"></a>			if (isset($one[$key]) && is_array($one[$key]) && is_array($item)) {
<a name="line1193"></a>				$one[$key] = $this->_mergeArrays($one[$key], $item);
<a name="line1194"></a>			} else {
<a name="line1195"></a>				$one[$key] = $item;
<a name="line1196"></a>			}
<a name="line1197"></a>		}
<a name="line1198"></a>		return $one;
<a name="line1199"></a>	}
<a name="line1200"></a>	
<a name="line1201"></a>	/**
<a name="line1202"></a>	 * Get next token of a certain type from token array
<a name="line1203"></a>	 *
<a name="line1204"></a>	 * @param str[] tokens Token array to search
<a name="line1205"></a>	 * @param int key Key to start searching from
<a name="line1206"></a>	 * @param int whatToGet Type of token to look for
<a name="line1207"></a>	 * @return str Value of found token
<a name="line1208"></a>	 */
<a name="line1209"></a>	function _getNext(&$tokens, $key, $whatToGet)
<a name="line1210"></a>    {
<a name="line1211"></a>		$key++;
<a name="line1212"></a>		if (!is_array($whatToGet)) $whatToGet = array($whatToGet);
<a name="line1213"></a>		while(!is_array($tokens[$key]) || !in_array($tokens[$key][0], $whatToGet)) {
<a name="line1214"></a>			$key++;
<a name="line1215"></a>			if (!isset($tokens[$key])) return FALSE;
<a name="line1216"></a>		}
<a name="line1217"></a>		return $tokens[$key][1];
<a name="line1218"></a>	}
<a name="line1219"></a>
<a name="line1220"></a>	/**
<a name="line1221"></a>	 * Get previous token of a certain type from token array
<a name="line1222"></a>	 *
<a name="line1223"></a>	 * @param str[] tokens Token array to search
<a name="line1224"></a>	 * @param int key Key to start searching from
<a name="line1225"></a>	 * @param int whatToGet Type of token to look for
<a name="line1226"></a>	 * @return str Value of found token
<a name="line1227"></a>	 */
<a name="line1228"></a>	function _getPrev(&$tokens, $key, $whatToGet)
<a name="line1229"></a>    {
<a name="line1230"></a>		$key--;
<a name="line1231"></a>		if (!is_array($whatToGet)) $whatToGet = array($whatToGet);
<a name="line1232"></a>		while(!is_array($tokens[$key]) || !in_array($tokens[$key][0], $whatToGet)) {
<a name="line1233"></a>			$key--;
<a name="line1234"></a>			if (!isset($tokens[$key])) return FALSE;
<a name="line1235"></a>		}
<a name="line1236"></a>		return $tokens[$key][1];
<a name="line1237"></a>	}
<a name="line1238"></a>	
<a name="line1239"></a>	/**
<a name="line1240"></a>	 * Get the next program element name from the token list
<a name="line1241"></a>	 *
<a name="line1242"></a>	 * @param mixed[] tokens
<a name="line1243"></a>	 * @param int key
<a name="line1244"></a>	 * @return str
<a name="line1245"></a>	 */
<a name="line1246"></a>	function _getProgramElementName(&$tokens, $key) {
<a name="line1247"></a>	    $name = '';
<a name="line1248"></a>	    $key++;
<a name="line1249"></a>	    while (
<a name="line1250"></a>	        $tokens[$key] && (
<a name="line1251"></a>                $tokens[$key] == '&' || (
<a name="line1252"></a>                    isset($tokens[$key][0]) && isset($tokens[$key][1]) && (
<a name="line1253"></a>                    $tokens[$key][0] == T_WHITESPACE ||
<a name="line1254"></a>                    $tokens[$key][0] == T_STRING ||
<a name="line1255"></a>                    $tokens[$key][0] == T_NS_SEPARATOR
<a name="line1256"></a>                )
<a name="line1257"></a>            )
<a name="line1258"></a>        )) {
<a name="line1259"></a>            if (isset($tokens[$key][1])) {
<a name="line1260"></a>                $name .= $tokens[$key][1];
<a name="line1261"></a>            }
<a name="line1262"></a>            $key++;
<a name="line1263"></a>        }
<a name="line1264"></a>        return trim($name);
<a name="line1265"></a>	}
<a name="line1266"></a>	
<a name="line1267"></a>	/**
<a name="line1268"></a>	 * Process a doc comment into a doc tag array.
<a name="line1269"></a>	 *
<a name="line1270"></a>	 * @param str comment The comment to process
<a name="line1271"></a>	 * @param RootDoc root The root object
<a name="line1272"></a>	 * @return mixed[] Array of doc comment data
<a name="line1273"></a>	 */
<a name="line1274"></a>	function processDocComment($comment, &$root)
<a name="line1275"></a>    {
<a name="line1276"></a>		if (substr(trim($comment), 0, 3) != '/**') return array(); // not doc comment, abort
<a name="line1277"></a>        
<a name="line1278"></a>		$data = array(
<a name="line1279"></a>			'docComment' => $comment,
<a name="line1280"></a>			'tags' => array()
<a name="line1281"></a>		);
<a name="line1282"></a>		
<a name="line1283"></a>		$explodedComment = preg_split('/\n[ \n\t\/]*\*[ \t]*@/', "\n".$comment);
<a name="line1284"></a>		
<a name="line1285"></a>		preg_match_all('/^[ \t]*[\/*]*\**( ?.*)[ \t\/*]*$/m', array_shift($explodedComment), $matches); // changed; we need the leading whitespace to detect multi-line list entries
<a name="line1286"></a>		if (isset($matches[1])) {
<a name="line1287"></a>			$txt = implode("\n", $matches[1]);
<a name="line1288"></a>			$data['tags']['@text'] = $this->createTag('@text', trim($txt, " \n\t\0\x0B*/"), $data, $root);
<a name="line1289"></a>		}
<a name="line1290"></a>		
<a name="line1291"></a>		foreach ($explodedComment as $tag) { // process tags
<a name="line1292"></a>            // strip whitespace, newlines and asterisks
<a name="line1293"></a>            $tag = preg_replace('/(^[\s\n\*]+|[\s\*]*\*\/$)/m', ' ', $tag); // fixed: empty comment lines at end of docblock
<a name="line1294"></a>            $tag = preg_replace('/\n+/', '', $tag);
<a name="line1295"></a>            $tag = trim($tag);
<a name="line1296"></a>			
<a name="line1297"></a>			$parts = preg_split('/\s+/', $tag);
<a name="line1298"></a>			$name = isset($parts[0]) ? array_shift($parts) : $tag;
<a name="line1299"></a>			$text = join(' ', $parts);
<a name="line1300"></a>			if ($name) {
<a name="line1301"></a>				switch ($name) {
<a name="line1302"></a>				case 'package': // place current element in package
<a name="line1303"></a>				case 'namespace':
<a name="line1304"></a>				    if (!$this->_ignorePackageTags) { // unless we're ignoring package tags
<a name="line1305"></a>				        $data['package'] = $text;
<a name="line1306"></a>				    }
<a name="line1307"></a>					break;
<a name="line1308"></a>				case 'var': // set variable type
<a name="line1309"></a>					$data['type'] = $text;
<a name="line1310"></a>					break;
<a name="line1311"></a>				case 'access': // set access permission
<a name="line1312"></a>					$data['access'] = $text;
<a name="line1313"></a>					break;
<a name="line1314"></a>				case 'final': // element is final
<a name="line1315"></a>					$data['final'] = TRUE;
<a name="line1316"></a>					break;
<a name="line1317"></a>				case 'abstract': // element is abstract
<a name="line1318"></a>					$data['abstract'] = TRUE;
<a name="line1319"></a>					break;
<a name="line1320"></a>				case 'static': // element is static
<a name="line1321"></a>					$data['static'] = TRUE;
<a name="line1322"></a>					break;
<a name="line1323"></a>				default: //create tag
<a name="line1324"></a>					$name = '@'.$name;
<a name="line1325"></a>					if (isset($data['tags'][$name])) {
<a name="line1326"></a>						if (is_array($data['tags'][$name])) {
<a name="line1327"></a>							$data['tags'][$name][] = $this->createTag($name, $text, $data, $root);
<a name="line1328"></a>						} else {
<a name="line1329"></a>							$data['tags'][$name] = array($data['tags'][$name], $this->createTag($name, $text, $data, $root));
<a name="line1330"></a>						}
<a name="line1331"></a>					} else {
<a name="line1332"></a>						$data['tags'][$name] =& $this->createTag($name, $text, $data, $root);
<a name="line1333"></a>					}
<a name="line1334"></a>				}
<a name="line1335"></a>			}
<a name="line1336"></a>		}
<a name="line1337"></a>		return $data;
<a name="line1338"></a>	}
<a name="line1339"></a>
<a name="line1340"></a>	/**
<a name="line1341"></a>	 * Create a tag. This method first tries to load a Taglet for the given tag
<a name="line1342"></a>	 * name, upon failing it then tries to load a PHPDoctor specialised tag
<a name="line1343"></a>	 * class (e.g. classes/paramtag.php), if it still has not found a tag class
<a name="line1344"></a>	 * it uses the standard tag class.
<a name="line1345"></a>	 *
<a name="line1346"></a>	 * @param str name The name of the tag
<a name="line1347"></a>	 * @param str text The contents of the tag
<a name="line1348"></a>	 * @param str[] data Reference to doc comment data array
<a name="line1349"></a>	 * @param RootDoc root The root object
<a name="line1350"></a>	 * @return Tag
<a name="line1351"></a>	 */
<a name="line1352"></a>	function &createTag($name, $text, &$data, &$root)
<a name="line1353"></a>    {
<a name="line1354"></a>		$class = substr($name, 1);
<a name="line1355"></a>		if ($class) {
<a name="line1356"></a>			$tagletFile = $this->makeAbsolutePath($this->fixPath($this->_tagletPath).substr($name, 1).'.php', $this->_path);
<a name="line1357"></a>			if (is_file($tagletFile)) { // load taglet for this tag
<a name="line1358"></a>				if (!class_exists($class)) require_once($tagletFile);
<a name="line1359"></a>				$tag =& new $class($text, $data, $root);
<a name="line1360"></a>				return $tag;
<a name="line1361"></a>			} else {
<a name="line1362"></a>			    $tagFile = $this->makeAbsolutePath('classes/'.$class.'Tag.php', $this->_path);
<a name="line1363"></a>				if (is_file($tagFile)) { // load class for this tag
<a name="line1364"></a>					$class .= 'Tag';
<a name="line1365"></a>					if (!class_exists($class)) require_once($tagFile);
<a name="line1366"></a>					$tag =& new $class($text, $data, $root);
<a name="line1367"></a>					return $tag;
<a name="line1368"></a>				} else { // create standard tag
<a name="line1369"></a>					$tag =& new tag($name, $text, $root);
<a name="line1370"></a>					return $tag;
<a name="line1371"></a>				}
<a name="line1372"></a>			}
<a name="line1373"></a>		}
<a name="line1374"></a>	}
<a name="line1375"></a>	
<a name="line1376"></a>	/**
<a name="line1377"></a>	 * Is an element private and we are including private elements, or element is
<a name="line1378"></a>	 * protected and we are including protected elements.
<a name="line1379"></a>	 *
<a name="line1380"></a>	 * @param ProgramElementDoc element The element to check
<a name="line1381"></a>	 * @return bool
<a name="line1382"></a>	 */
<a name="line1383"></a>	function _includeElements(&$element)
<a name="line1384"></a>    {
<a name="line1385"></a>		if ($element->isGlobal() && !$element->isFinal() && !$this->_globals) {
<a name="line1386"></a>			return FALSE;
<a name="line1387"></a>		} elseif ($element->isGlobal() && $element->isFinal() && !$this->_constants) {
<a name="line1388"></a>			return FALSE;
<a name="line1389"></a>        } elseif (!$this->_private && $element->isPrivate()) {
<a name="line1390"></a>            return FALSE;
<a name="line1391"></a>		} elseif ($this->_private) {
<a name="line1392"></a>			return TRUE;
<a name="line1393"></a>		} elseif ($this->_protected && ($element->isPublic() || $element->isProtected())) {
<a name="line1394"></a>			return TRUE;
<a name="line1395"></a>		} elseif ($this->_public && $element->isPublic()) {
<a name="line1396"></a>			return TRUE;
<a name="line1397"></a>		}
<a name="line1398"></a>		return FALSE;
<a name="line1399"></a>	}
<a name="line1400"></a>	
<a name="line1401"></a>	/**
<a name="line1402"></a>	 * Does the given element name conform to the format that is used for private
<a name="line1403"></a>	 * elements?
<a name="line1404"></a>	 *
<a name="line1405"></a>	 * @param str name The name to check
<a name="line1406"></a>	 * @return bool
<a name="line1407"></a>	 */
<a name="line1408"></a>	function _hasPrivateName($name)
<a name="line1409"></a>	{
<a name="line1410"></a>		return substr($name, 0, 1) == '_';
<a name="line1411"></a>	}
<a name="line1412"></a>	
<a name="line1413"></a>}
<a name="line1414"></a>
<a name="line1415"></a>?>
<a name="line1416"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/phpdoctor.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>